## hepmc 2.06.08

=== CMakeLists.txt ===
#------------------------------------------------------------------------------
# Top Level CMakeLists.txt for HepMC
#  cmake -Dmomentum:STRING=[MEV|GEV] -Dlength:STRING=[MM|CM]
#        [-DCMAKE_INSTALL_PREFIX=/install/path] 
#        [-DCMAKE_BUILD_TYPE=Debug|Release|RelWithDebInfo|MinSizeRel]
#        [-Dbuild_docs:BOOL=ON] 
#        /path/to/source
#  make
#  make test
#  make install
#
# The default HepMC build type is CMAKE_BUILD_TYPE=RelWithDebInfo,
# which matches the default HepMC autoconf flags
#------------------------------------------------------------------------------

# use cmake 2.6 or later
cmake_minimum_required (VERSION 2.6)

# project name and version
project(HepMC)
set( version 2.06.08 )

if ( momentum )
  set( HEPMC_DEFAULT_MOM_UNIT ${momentum} )
else()
  message(FATAL_ERROR "You must specify the momentum units with -Dmomentum:STRING=[MEV|GEV]")
endif()

if ( length )
  set( HEPMC_DEFAULT_LEN_UNIT ${length} )
else()
  message(FATAL_ERROR "You must specify the length units with -Dlength:STRING=[MM|CM]")
endif()

message(STATUS "default momentum and length are ${HEPMC_DEFAULT_MOM_UNIT} ${HEPMC_DEFAULT_LEN_UNIT}")

# find the HepMC cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules ${CMAKE_MODULE_PATH})

# make sure we are not building from within the source code directory
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" in_source)
string( REGEX MATCH "${CMAKE_SOURCE_DIR}/" in_source_subdir
"${CMAKE_BINARY_DIR}")
if (in_source OR in_source_subdir)
  message(FATAL_ERROR "
ERROR: In source builds of this project are not allowed.
A separate build directory is required.
Please create one and run cmake from the build directory.
Also note that cmake has just added files to your source code directory.
We suggest getting a new copy of the source code.
Otherwise, delete `CMakeCache.txt' and the directory `CMakeFiles'.
  ")
endif ()

# build_docs is OFF (false) by default
if ( build_docs )
   message(STATUS "documents WILL be built and installed" )
else()
   message(STATUS "documents WILL NOT be installed" )
endif()

# various handy macros
include(HepMCVariables)
#include(HepMCParseVersion)

# because we want to move these libraries about,
# do not embed full path in shared libraries or executables
set (CMAKE_SKIP_RPATH)

ENABLE_TESTING()

# include search path
include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")

#build all libraries in a single directory to facilitate testing
SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# parse the version 
STRING( REGEX REPLACE "^([0-9]+)[.][0-9]+[.][0-9]+.*" "\\1" VERSION_MAJOR "${version}" )
STRING( REGEX REPLACE "^[0-9]+[.]([0-9]+)[.][0-9]+.*" "\\1" VERSION_MINOR "${version}" )
STRING( REGEX REPLACE "^[0-9]+[.][0-9]+[.]([0-9]+)+.*" "\\1" VERSION_PATCH "${version}" )
message(STATUS "${project} version ${version} parses to ${VERSION_MAJOR} ${VERSION_MINOR} ${VERSION_PATCH}" )

# set our preferred compiler flags and other variables
include(CMakeDetermineFortranCompiler)
hepmc_set_compiler_flags()

add_subdirectory(HepMC) 
add_subdirectory(src) 
add_subdirectory(fio) 
add_subdirectory(test) 
add_subdirectory(examples) 
add_subdirectory(doc)

# Packaging utility
include(HepMCUseCpack)

=== examples/CMakeLists.txt ===

set( example_code 
		  example_BuildEventFromScratch.cc
		  example_EventSelection.cc
		  example_UsingIterators.cc
		  example_UsingIterators.txt
		  example_VectorConversion.cc
		  VectorConversion.h
		    )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/GNUmakefile.example.in 
                ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile  @ONLY )

INSTALL (FILES ${example_code}  
               ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile
         DESTINATION share/HepMC/examples )

add_subdirectory(fio) 
add_subdirectory(pythia8)

=== fio/CMakeLists.txt ===

set ( fio_source_list    
			 HEPEVT_Wrapper.cc
			 HerwigWrapper.cc
			 IO_HEPEVT.cc
			 IO_HERWIG.cc
			  )

# this library is meant to interact with Fortran and needs extra flags
    if(APPLE)
      set( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS 
           "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} -Wl,-undefined -Wl,dynamic_lookup -Wl,-single_module")
    endif(APPLE)

ADD_LIBRARY (HepMCfio  SHARED ${fio_source_list})
ADD_LIBRARY (HepMCfioS STATIC ${fio_source_list})
SET_TARGET_PROPERTIES (HepMCfio  PROPERTIES OUTPUT_NAME HepMCfio )
SET_TARGET_PROPERTIES (HepMCfio  PROPERTIES VERSION 4.0.0 SOVERSION 4 )
SET_TARGET_PROPERTIES (HepMCfioS PROPERTIES OUTPUT_NAME HepMCfio )
SET_TARGET_PROPERTIES(HepMCfio  PROPERTIES CLEAN_DIRECT_OUTPUT 1)
SET_TARGET_PROPERTIES(HepMCfioS PROPERTIES CLEAN_DIRECT_OUTPUT 1)

INSTALL (TARGETS HepMCfio HepMCfioS
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    )

=== debian/changelog ===
hepmc (2.06.08-1) unstable; urgency=low

  * Initial release (Closes: #636976)

 -- Lifeng Sun <lifongsun@gmail.com>  Sun, 20 May 2012 14:26:51 +0800

=== debian/control ===
Source: hepmc
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Lifeng Sun <lifongsun@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, doxygen-latex, ghostscript, texlive-math-extra, dh-autoreconf
Standards-Version: 3.9.3
Homepage: http://lcgapp.cern.ch/project/simu/HepMC/
Vcs-Git: git://git.debian.org/git/debian-science/packages/hepmc.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/hepmc.git

Package: libhepmc4
Section: libs
Architecture: any
Multi-arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libhepmcfio
Suggests: libhepmc-dev, libhepmcfio-dev
Description: Event Record for Monte Carlo Generators
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package. 

Package: libhepmc-dev
Section: libdevel
Architecture: any
Depends: libhepmc4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libhepmcfio-dev
Suggests: hepmc-examples, hepmc-user-manual, hepmc-reference-manual
Description: Event Record for Monte Carlo Generators - development files
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides development files of HepMC.

Package: libhepmcfio4
Section: libs
Architecture: any
Multi-arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhepmc4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: libhepmcfio-dev, libhepmc-dev
Description: fio library of HepMC
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 The fio library of HepMC provides wrappers of HEPEVT, Pythia and Herwig.

Package: libhepmcfio-dev
Section: libdevel
Architecture: any
Depends: libhepmc-dev (= ${binary:Version}), libhepmcfio4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: hepmc-example, hepmc-user-manual, hepmc-reference-manual
Description: fio library of HepMC - development files
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides development files of fio library of HepMC.

Package: hepmc-examples
Section: devel
Architecture: all
Depends: libclhep-dev, libpythia8-dev, libhepmc-dev (>= ${source:Version}), libhepmcfio-dev (>= ${source:Version}), ${misc:Depends}
Suggests: hepmc-user-manual, hepmc-reference-manual
Description: Event Record for Monte Carlo Generators - example files
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides example source files of HepMC.

Package: hepmc-user-manual
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: libhepmc-dev, libhepmcfio-dev
Suggests: hepmc-reference-manual
Description: Event Record for Monte Carlo Generators - User Manual
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides HepMC2 User Manual.

Package: hepmc-reference-manual
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: libhepmc-dev, libhepmcfio-dev, hepmc-user-manual
Description: Event Record for Monte Carlo Generators - Reference Manual
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides HepMC2 Reference Manual.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

export CPPFLAGS CFLAGS CXXFLAGS LDFLAGS MAKEFLAGS

clean:
	dh_testdir
	dh_autoreconf_clean
	dh_auto_clean
	dh_clean

configure-stamp:
	dh_testdir
	dh_autoreconf
	dh_auto_configure -- \
		--with-momentum=GEV \
		--with-length=MM \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
	touch $@

override_dh_auto_install:
	dh_testdir
	dh_auto_install
	rm -f debian/tmp/usr/share/HepMC/examples/pythia8/config.sh
	rm -f debian/tmp/usr/share/HepMC/examples/pythia8/config.csh
	rm -f debian/tmp/usr/share/HepMC/examples/pythia8/README

build-arch: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

build-indep: configure-stamp
	dh_testdir
	cd doc; ./buildDoc.sh

build: build-arch

binary-arch: build-arch
	dh $@

binary-indep: build-indep
	dh $@

binary: binary-arch binary-indep

.PHONY: build build-arch build-indep binary binary-arch binary-indep

=== debian/watch ===
version=3

http://lcgapp.cern.ch/project/simu/HepMC/download/index.html HepMC-([\d\.]+).tar.gz

## hepmc 2.06.09

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 # project name and version
 project(HepMC)
-set( version 2.06.08 )
+set( version 2.06.09 )
 
 if ( momentum )
   set( HEPMC_DEFAULT_MOM_UNIT ${momentum} )

=== HepMC/CMakeLists.txt ===

set( pkginclude_HEADERS 
		    CompareGenEvent.h
		    Flow.h	
		    GenEvent.h
		    GenParticle.h
		    GenVertex.h
		    GenCrossSection.h
		    GenRanges.h
		    HeavyIon.h
		    HEPEVT_Wrapper.h
		    HerwigWrapper.h
		    IO_AsciiParticles.h
		    IO_BaseClass.h
		    IO_Exception.h
		    IO_GenEvent.h
		    IO_HEPEVT.h
		    IO_HERWIG.h
		    IteratorRange.h
		    PdfInfo.h
		    Polarization.h
		    PythiaWrapper6_4.h
		    PythiaWrapper6_4_WIN32.h
		    PythiaWrapper.h
		    WeightContainer.h
		    SearchVector.h
		    SimpleVector.h
		    SimpleVector.icc	
		    StreamHelpers.h
		    StreamInfo.h
		    enable_if.h
		    is_arithmetic.h
		    TempParticleMap.h
		    Units.h
		    Version.h
		    HepMCDefs.h
		    )

INSTALL (FILES ${pkginclude_HEADERS}  
         DESTINATION include/HepMC )

=== doc/CMakeLists.txt ===
# build HepMC documentation
# for documentation

if ( build_docs )

find_package(LATEX)
find_package(Doxygen)

macro( hepmc_latex package main_tex_file )
IF(LATEX_COMPILER)
   FOREACH(arg ${ARGN})  
     CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/${arg} 
                     ${CMAKE_CURRENT_BINARY_DIR}/${arg}  COPYONLY)
     set( depend_list ${arg} ${depend_list} )
   ENDFOREACH(arg) 
   ##message(STATUS "${package} ${main_tex_file} depends on ${depend_list}" )
   ADD_CUSTOM_COMMAND( 
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.aux
    COMMAND   ${LATEX_COMPILER}
              -interaction=batchmode ${CMAKE_CURRENT_SOURCE_DIR}/${main_tex_file}
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${main_tex_file}.tex ${depend_list}
    COMMENT   "Latex - first pass"
  )
   ADD_CUSTOM_COMMAND( 
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.dvi
    COMMAND   ${LATEX_COMPILER}
              -interaction=batchmode ${CMAKE_CURRENT_SOURCE_DIR}/${main_tex_file}
    DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.aux
    COMMENT   "Latex - second pass"
  )
   ADD_CUSTOM_COMMAND( 
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.log
    COMMAND   ${LATEX_COMPILER}
              -interaction=batchmode ${CMAKE_CURRENT_SOURCE_DIR}/${main_tex_file}
    DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.dvi
    COMMENT   "Latex - third pass"
  )
  ADD_CUSTOM_TARGET(${main_tex_file} ALL echo
    DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.log
    )

IF(DVIPS_CONVERTER)
    ADD_CUSTOM_COMMAND( 
      OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.ps
      COMMAND   ${DVIPS_CONVERTER}
                ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.dvi
                -o ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.ps
      DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.dvi
      COMMENT   "dvi2ps"
   )

 IF(PS2PDF_CONVERTER)
    ADD_CUSTOM_COMMAND( 
      OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.pdf
      COMMAND   ${PS2PDF_CONVERTER}
                ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.ps
      DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.ps
      COMMENT   "ps2pdf"
    )

 ADD_CUSTOM_TARGET( ${package}${main_tex_file}Document ALL echo
      DEPENDS   ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.pdf
    )
    ENDIF(PS2PDF_CONVERTER)
  ENDIF(DVIPS_CONVERTER)
ENDIF(LATEX_COMPILER)

INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/${main_tex_file}.pdf
         DESTINATION share/HepMC/doc )
endmacro( hepmc_latex )

# use the macro to build the user manual
hepmc_latex( HepMC HepMC2_user_manual 
                   graph_interpretation.eps 
		   HepMC_basic_properties.eps
		   physicist_visualization.eps )

# now try doxygen
IF (DOXYGEN_FOUND)
  SET(DOXYGEN_INPUT doxygen.conf)
  SET(DOXYGEN_OUTPUT ${CMAKE_BINARY_DIR}/html/index.html )

  ADD_CUSTOM_COMMAND(
    OUTPUT ${DOXYGEN_OUTPUT}
    COMMAND ${CMAKE_COMMAND} -E echo_append "Building HepMC Documentation..."
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
    COMMAND ${CMAKE_COMMAND} -E echo "Done."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${DOXYGEN_INPUT}
    )

  ADD_CUSTOM_TARGET(hepmcdoc ALL DEPENDS ${DOXYGEN_OUTPUT})

  ADD_CUSTOM_TARGET(hepmcdoc_forced
    COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
    COMMAND ${CMAKE_COMMAND} -E echo "Done."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )

ENDIF (DOXYGEN_FOUND)

else( build_docs )

# look for existing pdf files
FILE( GLOB pdf_files *.pdf )
INSTALL (FILES ${pdf_files}
         DESTINATION share/HepMC/doc )


endif( build_docs )

=== fio/CMakeLists.txt ===

set ( fio_source_list    
			 HEPEVT_Wrapper.cc
			 HerwigWrapper.cc
			 IO_HEPEVT.cc
			 IO_HERWIG.cc
			  )

# this library is meant to interact with Fortran and needs extra flags
    if(APPLE)
      set( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS 
           "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} -Wl,-undefined -Wl,dynamic_lookup -Wl,-single_module")
    endif(APPLE)

# give up and only build static library for Windows
if( ${CMAKE_SYSTEM_NAME} MATCHES "Windows" )
      set( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS 
           "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} /ALLOWISOLATION:NO /FORCE:UNRESOLVED")
else()
ADD_LIBRARY (HepMCfio  SHARED ${fio_source_list})
SET_TARGET_PROPERTIES (HepMCfio  PROPERTIES OUTPUT_NAME HepMCfio )
SET_TARGET_PROPERTIES (HepMCfio  PROPERTIES VERSION 4.0.0 SOVERSION 4 )
SET_TARGET_PROPERTIES(HepMCfio  PROPERTIES CLEAN_DIRECT_OUTPUT 1)
INSTALL (TARGETS HepMCfio 
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    ) 
endif()

ADD_LIBRARY (HepMCfioS STATIC ${fio_source_list})
SET_TARGET_PROPERTIES (HepMCfioS PROPERTIES OUTPUT_NAME HepMCfio )
SET_TARGET_PROPERTIES(HepMCfioS PROPERTIES CLEAN_DIRECT_OUTPUT 1)

INSTALL (TARGETS HepMCfioS
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    )

=== test/CMakeLists.txt ===


macro( hepmc_test testname )

  message( STATUS "building ${testname} for ${testname}.sh" )

  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR}
${CMAKE_CURRENT_BINARY_DIR} )
  ADD_EXECUTABLE(${testname} ${${testname}_source} ${ARGN} )
 
  if( ${CMAKE_SYSTEM_NAME} MATCHES "Windows" )
    message( STATUS "skipping ${testname}.sh on ${CMAKE_SYSTEM_NAME}")
  else()
    # automake/autoconf variables for ${testname}.sh.in 
    set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
    set(builddir ${CMAKE_CURRENT_BINARY_DIR} )
    configure_file( ${testname}.sh.in 
                    ${CMAKE_CURRENT_BINARY_DIR}/${testname}.sh  @ONLY )
    add_test( ${testname}.sh ${CMAKE_CURRENT_BINARY_DIR}/${testname}.sh )
  endif()

endmacro( hepmc_test )

macro( hepmc_simple_test testname )

  message( STATUS "building simple test ${testname} " )

  # include test in search path
  include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")

  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR}
${CMAKE_CURRENT_BINARY_DIR} )
  #message(STATUS "building simple test ${testname} from ${${testname}_source}")
  ADD_EXECUTABLE(${testname} ${${testname}_source} ${ARGN} )

  add_test( ${testname} ${testname} )

endmacro( hepmc_simple_test )


link_libraries( HepMC )

set( HepMC_tests 
		 testHepMCIteration
		 testMass
		 testFlow
                 testPrintBug
		 testPolarization )
set( HepMC_simple_tests testSimpleVector 
                	testUnits
			testMultipleCopies 
			testWeights )

# automake/autoconf variables for *.cc.in 
set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )

FILE( GLOB process_source *.cc.in )
foreach( sfile ${process_source} )
  get_filename_component(basename ${sfile} NAME_WE )
  configure_file( ${sfile}
                  ${CMAKE_CURRENT_BINARY_DIR}/${basename}.cc  @ONLY )
endforeach( sfile ${process_source} )

hepmc_test( testHepMC testHepMCMethods.cc )
hepmc_test( testStreamIO testHepMCMethods.cc )

foreach ( test ${HepMC_tests} )
  hepmc_test( ${test} )
endforeach ( test ${HepMC_tests} )

foreach ( test ${HepMC_simple_tests} )
  hepmc_simple_test( ${test} )
endforeach ( test ${HepMC_simple_tests} )

=== examples/fio/CMakeLists.txt ===

set( example_code 
		  example_MyHerwig.cc
		  example_MyPythia.cc
		  example_MyPythiaOnlyToHepMC.cc
		  example_PythiaStreamIO.cc
		  initpydata.f
		  initPythia.cc
		  PythiaHelper.h
		  testHerwigCopies.cc
		  testPythiaCopies.cc
		    )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/GNUmakefile.example.in 
                ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile  @ONLY )

INSTALL (FILES ${example_code}  
               ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile
         DESTINATION share/HepMC/examples/fio )

=== examples/pythia8/CMakeLists.txt ===

set( example_code 
		  main31.cc
		  main32.cc
		  main32.cmnd
		  README
		  )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/GNUmakefile.example.in 
                ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile  @ONLY )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/config.csh.in
                ${CMAKE_CURRENT_BINARY_DIR}/config.csh  @ONLY )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/config.sh.in
                ${CMAKE_CURRENT_BINARY_DIR}/config.sh  @ONLY )

INSTALL (FILES ${example_code}  
               ${CMAKE_CURRENT_BINARY_DIR}/GNUmakefile
               ${CMAKE_CURRENT_BINARY_DIR}/config.csh
               ${CMAKE_CURRENT_BINARY_DIR}/config.sh
         DESTINATION share/HepMC/examples/pythia8 )

=== debian/changelog ===
hepmc (2.06.09-1) unstable; urgency=low

  * New upstream.
  * debian/control: move doxygen-latex, ghostscript, texlive-math-extra to
    build-dep-indep.
  * debian/copyright: fix licence version.
  * debian/rules: support get-orig-source rule.

 -- Lifeng Sun <lifongsun@gmail.com>  Thu, 21 Jun 2012 19:59:00 +0800

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Lifeng Sun <lifongsun@gmail.com>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, doxygen-latex, ghostscript, texlive-math-extra, dh-autoreconf
+Build-Depends: debhelper (>= 7.0.50~), autotools-dev, dh-autoreconf
+Build-Depends-Indep: doxygen-latex, ghostscript, texlive-math-extra
 Standards-Version: 3.9.3
 Homepage: http://lcgapp.cern.ch/project/simu/HepMC/
 Vcs-Git: git://git.debian.org/git/debian-science/packages/hepmc.git

=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,4 @@
 #!/usr/bin/make -f
-# -*- makefile -*-
-# Sample debian/rules that uses debhelper.
-#
-# This file was originally written by Joey Hess and Craig Small.
-# As a special exception, when this file is copied by dh-make into a
-# dh-make output file, you may use that output file without restriction.
-# This special exception was added by Craig Small in version 0.37 of dh-make.
-#
-# Modified to make a template file for a multi-binary package with separated
-# build-arch and build-indep targets  by Bill Allombert 2001
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -24,10 +14,26 @@
 LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-	MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+else
+	NUMJOBS := 1
 endif
 
-export CPPFLAGS CFLAGS CXXFLAGS LDFLAGS MAKEFLAGS
+export CPPFLAGS CFLAGS CXXFLAGS LDFLAGS
+
+# package name
+PKGNAME=$(strip $(shell head -n1 debian/changelog | cut -d' ' -f1))
+
+# current Debian package version
+DEBVER=$(strip $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()'))
+
+# current upstream version (remove any epoch and Debian release number)
+UPVER=$(shell echo $(DEBVER) | sed -e 's/-[^-]*$$//' -e 's/^[^:]*://')
+
+../$(PKGNAME)_$(UPVER).orig.tar.gz:
+	./debian/get-orig-source --upstream-version $(UPVER) $@
+
+get-orig-source: ../$(PKGNAME)_$(UPVER).orig.tar.gz
 
 clean:
 	dh_testdir
@@ -53,7 +59,7 @@
 
 build-arch: configure-stamp
 	dh_testdir
-	$(MAKE) $(MAKEFLAGS)
+	$(MAKE) -j$(NUMJOBS)
 
 build-indep: configure-stamp
 	dh_testdir
@@ -69,4 +75,4 @@
 
 binary: binary-arch binary-indep
 
-.PHONY: build build-arch build-indep binary binary-arch binary-indep
+.PHONY: build build-arch build-indep binary binary-arch binary-indep get-orig-source

=== debian/watch ===
version=3

http://lcgapp.cern.ch/project/simu/HepMC/download/index.html HepMC-([\d\.]+).tar.gz debian ./debian/get-orig-source
